#version 150
uniform sampler2D sampler0;

uniform vec3 sun;
uniform float shiny;
uniform float brightness;

in vec4 vertexCoord;
in vec3 normal;
in vec4 color;
in vec4 texcoord0;

out vec4 frag_color;

void main() {
    frag_color = color * texture2DProj(sampler0, texcoord0);
	float multiplier = clamp(-dot(normal, sun), 0.25 + brightness, 1.0 + brightness);
	frag_color.rgb *= vec3(multiplier);
	
	// compute eye vector and normalize it 
	vec3 eye = normalize(-vertexCoord.xyz);
	// compute the half vector
	vec3 h = normalize(-sun + eye);

	// compute the specular term into spec
	float intSpec = max(dot(h,normal), 0.0);
	float spec = (0.5 + shiny) * pow(intSpec, 16.0);
	
	frag_color.rgb += vec3(spec);
}