#version 150

uniform sampler2D renderSampler;
uniform float bloomAlpha;
uniform float texAspect;
uniform float xMax;
uniform float yMax;
uniform float xUnit;
uniform float yUnit;

in vec4 color;
in vec4 texcoord0;

out vec4 frag_color;

void main()
	{
	vec2 texCoord = vec2(texcoord0);
    vec3 colorSum = vec3(0.0);
    
    /*const*/ float len = 0.0025;
    /*const*/ vec2 maximum = vec2(xMax-xUnit, yMax-yUnit);
    float i,j;
    
	for( i=-5.0 ; i < 6.0; i+=1.0)
	    {
	    for( j=5.0-abs(i) ; j > 0.0 ; j-=1.0)
			{
			vec2 offset = vec2(j,i*texAspect)*len;
		    colorSum += texture2D(renderSampler, min(texCoord+offset,maximum)).rgb*0.06;
		    colorSum += texture2D(renderSampler, texCoord-offset).rgb*0.06;
			}
		} 
    frag_color.rgb = texture2D(renderSampler, texCoord).rgb + colorSum * bloomAlpha;
    frag_color.a = color.a;
	}
	