#version 150

uniform sampler2D renderSampler;
uniform float bloomAlpha;
uniform float texAspect;
uniform vec2 maximum;

in vec4 color;
in vec4 texcoord0;

out vec4 frag_color;

/*This shader only renders the bloom contribution to the target color buffer (rgb only).*/

void main()
{
	vec2 texCoord = vec2(texcoord0);
    frag_color.rgb = vec3(0.0);
    
    /*const*/ float len = 0.0025;
    float i,j;
    
	for( i=-5.0 ; i < 6.0; i+=1.0)
	{
	    for( j=5.0-abs(i) ; j > 0.0 ; j-=1.0)
		{
			vec2 offset = vec2(j,i*texAspect)*len;
		    frag_color.rgb += bloomAlpha * texture2D(renderSampler, min(texCoord+offset,maximum)).rgb*0.06;
		    frag_color.rgb += bloomAlpha * texture2D(renderSampler, min(texCoord-offset,maximum)).rgb*0.06;
		}
	} 
}
	