#version 150

uniform sampler2D sampler0;
uniform sampler2D sampler1;

in vec4 texcoord0;

out vec4 frag_color;

// ease is 0-1
uniform float ease;
// crumble is 1-inf
uniform float crumble;
// when to discard
uniform float discardAt;

void main(){
	if (mix(1.0, texture2D(sampler1, texcoord0.xy).r, ease) / crumble <= discardAt)
		discard;
	frag_color = texture2D(sampler0, texcoord0.xy);
}