#version 150

uniform sampler2D sampler0; //2D rgba texture - xy: texcoord0 - rg: Fractional sprite coordinates, b: Side coordinate, a: Cube ordinal index (as unsigned byte)
uniform sampler2D sampler1; //2D rgb texture - x: Side coordinate, y: Cube ordinal index - rg: Base sprite coordinates, b: Brightness constant 
uniform sampler2D sampler2; //2D rgb texture - xy: sprite coordinates - rgb: terrain texture atlas
uniform sampler2D sampler3; //2D r texture - xy: texcoord0 - r: Depth

uniform float fogNear;
uniform float fogFar;

uniform float zFar3D;

float transformDepth(float z_b)
{
	//!!!!
	const float zNear = 0.0625;
	// conversion into NDC [-1,1]
	z_b = z_b * 2.0 - 1.0;
	// cozNearversiozNear izNearto eye space
	return (2.0 * zNear * zFar3D / (zFar3D+zNear - z_b * (zFar3D - zNear)));
}

in vec4 color;
in vec4 texcoord0;

out vec4 fragColor;

void main() {
    float depth = texture2DProj(sampler3, texcoord0).r;
    float fogFactor = clamp((transformDepth(depth)-fogNear)/(fogFar-fogNear), 0.0, 1.0);
    gl_FragDepth = depth;
    
    vec4 fxfysc = texture2DProj(sampler0, texcoord0);
    vec3 bxbyb = texture(sampler1, fxfysc.ba).rgb;
    vec3 rgb = texture(sampler2, bxbyb.xy + fxfysc.xy/17.0).rgb;
    fragColor = (1.0-fogFactor) * vec4(vec3(bxbyb.b) * rgb, 1.0);
}