#version 150
uniform sampler2D sampler0;
uniform sampler2D sampler1;
#ifdef SAMPLER2
uniform sampler2D sampler2;
#endif
#ifdef SAMPLER3
uniform sampler2D sampler3;
#endif

in vec3 normal;
in vec4 color;
in vec4 texcoord0;

out vec4 frag_color;

void main() {
    frag_color = color * texture2DProj(sampler0, texcoord0) * texture2DProj(sampler1, texcoord0);
    #ifdef SAMPLER2
    frag_color *= texture2DProj(sampler2, texcoord0);
    #endif
    #ifdef SAMPLER3
    frag_color *= texture2DProj(sampler3, texcoord0);
    #endif
}