#version 150
uniform sampler2D sampler0; //source texture

#ifdef Palette
uniform sampler1D sampler1; //palette texture
#endif

#ifdef Colorize
uniform vec3 black;
uniform vec3 white;
#endif

in vec4 texcoord0;

out vec4 frag_color;

void main(){
	#ifdef Palette
	frag_color = texture(sampler1, texture2D(sampler0, texcoord0.xy).r);
	#else
	frag_color = texture2DProj(sampler0, texcoord0);
	#endif
	
	#ifdef Colorize
	frag_color = vec4(mix(black, white, .299*frag_color.r+.587*frag_color.g+.114*frag_color.b), frag_color.a);
	#endif
}