#version 150
uniform sampler2D sampler0;
uniform float depth;

in vec4 color;
in vec4 texcoord0;

out vec4 fragColor;

void main() {
	vec4 rawColor = texture2DProj(sampler0, texcoord0) * color;
	#ifdef ALPHA
	fragColor = floor(rawColor * vec4(depth)) / vec4(depth);
	#else
	fragColor = vec4(floor(rawColor.rgb * vec3(depth)) / vec3(depth), rawColor.a);
	#endif
}