#version 150
uniform sampler2D sampler0;
uniform sampler2D sampler1;

#ifdef Blended
uniform vec4 blendColor;
uniform sampler2D sampler2;
#endif

in vec4 color;
in vec4 texcoord0;

out vec4 fragColor;

uniform vec2 translate;
uniform vec2 scale;

void main() {
		fragColor = texture2D(sampler0, (texcoord0.xy + translate) * scale) * vec4(1.0, 1.0, 1.0, texture2DProj(sampler1, texcoord0).r);
		#ifdef Blended
		fragColor = mix(fragColor, vec4(texture2DProj(sampler2, texcoord0).r), texture2DProj(sampler2, texcoord0).r);//vec4(texture2DProj(sampler2, texcoord0).r);//mix(blendColor, fragColor, texture2DProj(sampler2, texcoord0).r);//
		#endif
		fragColor *= color;
}