#version 150
uniform sampler2D sampler0;
uniform sampler2D sampler1;
uniform sampler2D sampler2;

uniform float distortionMinimum;

in vec4 texcoord0;

out vec4 fragColor;

float getFactor(float min, float max, float value)
{
	return (value - min) / (max - min);
}

void main() {
	float rawDistortionFactor = texture2DProj(sampler1, texcoord0).r;
	vec4 sourceColor = vec4(texture2DProj(sampler0, texcoord0).rgb, 1);

	float distortionFactor = max(-1.33, getFactor(distortionMinimum, 1, rawDistortionFactor));
	vec3 blurredColor = texture2DProj(sampler2, texcoord0).rgb;
	fragColor = vec4(mix(sourceColor.rgb, blurredColor, distortionFactor), 1) + vec4(max(0, distortionFactor) * 0.1);
}