#version 150

// camera position in tulip space
uniform vec2 rounded_camera_position;

// pseudorandom multiplier
uniform float pseudorandom_multiplier;

// heightmap
uniform sampler2D sampler0;

// xy-scale of heightmap
uniform float map_scale;

// size of the texture
uniform float heightmap_size;

// max z of heightmap
uniform float max_displacement;

// tulip amount!!
uniform float tulip_amount;

out vec4 frag_color;

void main(){
	vec2 coord = rounded_camera_position + gl_FragCoord.xy - vec2(.5 + tulip_amount/2.0); //get the base coordinate for the current tulip in tulip space
	
	//functions of gl_FragCoord and camera_position
	vec2 mutate = vec2(	coord.x + pseudorandom_multiplier * (1.0 - mod(coord.x * 1.25 - (.69 + coord.y) * 2.75 + sin((coord.y + .1) * (coord.x + .025)), 2.0)),
						coord.y + pseudorandom_multiplier * cos((.42 + coord.x) * (coord.y - 1.0) * 2.25 + cos(coord.x - (coord.y + 1.0) * 2 * (coord.y + 1.0))));
	//fuck with the tulip space stuff and convert to world space
	
	vec2 norm = (mutate + vec2(map_scale/2.0)) / vec2(map_scale);
	frag_color = vec4(mutate, texture2D(sampler0, norm).r * max_displacement, 1.0); //or maybe vec4 with last value 1?
}