#version 150

uniform sampler3D sampler0; //3D 'r' texture containing voxel data

uniform float baseZ;

in vec4 texcoord0; //xyz coordinate into voxel data (needs to be manually rounded, but not scaled)
in vec4 texcoord1; //xy = for computing fractional part into texture atlas, z = side index (pre-encoded to fit as-is)

out vec4 frag_color;

void main() {
    float material = texelFetch(sampler0, ivec3(texcoord0), 0).r;
    if(material <= 31.5/256.0)//0 through 31 are transparent cubes
       discard;
    frag_color.rg = fract(texcoord1.rg);
    frag_color.b = texcoord1.b;
    frag_color.a = material;
}