#version 150
// object space to camera space transformation
uniform mat4 modelview_matrix;
 
// camera space to clip coordinates
uniform mat4 projection_matrix;

uniform float baseZ;
 
// incoming vertex position
in vec4 vertex_position;
// incoming vertex texcoord
in vec4 vertex_texcoord0;
in vec4 vertex_texcoord1;

// eye space vertex coordinate
out vec4 vertexCoord;
// transformed texture coordinate
out vec4 texcoord0;
out vec4 texcoord1;
 
void main(void) {
	texcoord0 = vertex_texcoord0;
	texcoord0.z += baseZ;
	texcoord1 = vertex_texcoord1;
	
	// transforming the incoming vertex position
	vertexCoord = modelview_matrix * vertex_position;
	gl_Position = projection_matrix * vertexCoord;
}